#1 - 02/28/2024 01:11 PM - Vladimir Tsichevski

This task is dedicated to issues related to FILL-IN with character format.

#2 - 02/28/2024 01:22 PM - Vladimir Tsichevski

If the SCREEN-VALUE of the FILL-IN is set to unknown, the screen value is replaced by ? as expected, but this question mark cannot be erased

neither with Delete, Backspace nor with delete selection operation.

If the user enters any valid input character though, the question mark is replaced by the entered character as expected.

#3 - 02/28/2024 01:29 PM - Vladimir Tsichevski

If the user enters the ? in the first position, the screen value is replaced by ? as expected.

If the user moves the cursor right the the Right-Arrow, then presses Delete, the ? character is deleted. The Delete key in this situation behaves in

FWD similar to Backspace

In OE no deletion happens in this situation.

#5 - 02/28/2024 03:13 PM - Vladimir Tsichevski

In character mode, the Home and End keys should move the focus the the first and the last item in the focused widget ring.

In FWD, these keys work as in GUI mode: they move cursor in the focused FILL-IN to the first and last positions.

So, this issue is not limited by the character editing fill-ins.

#6 - 02/28/2024 03:15 PM - Vladimir Tsichevski

Vladimir Tsichevski wrote:

In character mode, the Home and End keys should move the focus the the first and the last item in the focused widget ring.

In FWD, these keys work as in GUI mode: they move cursor in the focused FILL-IN to the first and last positions.

So, this issue is not limited by the character editing fill-ins.
This issue is probably affected by the fact I was comparing the FWD Swing ChUI mode with OE on Windows. Probably, OE character mode on Linux

behaves differently.

#7 - 02/29/2024 11:50 AM - Vladimir Tsichevski

- File 8365-7-OE.png added

- File 8365-7-FWD.png added

OE displays the TAB character in character FILL-IN, but FWD does not.

The test program:

DEFINE VARIABLE fillIn AS CHARACTER NO-UNDO VIEW-AS FILL-IN.

DEFINE FRAME mainFrame

  fillIn

  WITH SIZE 75 BY 20 AT ROW 3 COL 5.

fillIn:SCREEN-VALUE = "a~tb".

ASSIGN fillIn.

MESSAGE fillIn LENGTH(fillIn).

MESSAGE fillIn:SCREEN-VALUE LENGTH(fillIn:SCREEN-VALUE).

ENABLE ALL WITH FRAME mainFrame.

WAIT-FOR GO OF FRAME mainFrame.

 

The screen in OE:
the same screen in FWD:

 

#8 - 02/29/2024 01:01 PM - Vladimir Tsichevski

Another issue: the trailing whithespace characters other than SPACE must not be trimmed in fillIn:SCREEN-VALUE.
In FWD trailing all whitespace characters are trimmed.

#9 - 02/29/2024 01:17 PM - Vladimir Tsichevski

Vladimir Tsichevski wrote:

Another issue: the trailing whithespace characters other than SPACE must not be trimmed in fillIn:SCREEN-VALUE.

In FWD trailing all whitespace characters are trimmed.

 

This happens here (GenericWidget):

   character getScreenValue(boolean initialized, BaseDataType bdt, String fmt, boolean ignoreFormat)

   {

      if (!initialized)

      {

         return new character("");

      }

      if (bdt.isUnknown())

      {

         return bdt.getClass().isAssignableFrom(date.class) ? new character("") : new character();

      }

      // format the value

      // TODO: is this always the same as the way the display would format it?

      // some widgets like selection-list can have screen value outside the format in multiple

      // selection case so we need the option to get this value too

      String formatted = ignoreFormat ? bdt.toStringMessage() : bdt.toString(fmt);

      ...                                                       ^^^^^^^^^^^^^^^^^

 

When the value is formatted, all kinds of trailing whitespaces are replaces by spaces.

I do not know whether it is the formatting we should fix, or we should not use formatting here at all.
